# -*- coding: utf-8 -*-

# Generates ProVerif input euqational theory and procMachine for a given number of bidders and prices
# Output is stored in file woodako-gen.pi

def getString(number):
    if number==0:
        return "empty"
    if number==1:
        return "one"
    if number==2:
        return "two"
    if number==3:
        return "three"
    if number==4:
        return "four"
    if number==5:
        return "five"
    if number==6:
        return "six"
    if number==7:
        return "seven"
    if number==8:
        return "eight"
    if number==9:
        return "nine"
    if number==10:
        return "ten"
    else:
        return "error"

def printHeader(bidders, prices, file):
    file.write("""type ball.
type key.
type box.
type tuple.\n\n""")

    for k in range(1,prices+1):
        file.write("const %s:ball.\n" % getString(k))
    file.write("""const empty:ball.
const something:ball.

const none:key.

fun tup(ball,ball):tuple [data].\n\n""")
    file.write("fun machine(");
    for k in range(bidders*prices):
        file.write("ball, ")
    for k in range(((bidders+1)*prices)+2*bidders+2):
        file.write("key, ")
    for k in range((bidders*prices)-1):
        file.write("ball, ")
    file.write("ball):box.\n\n")

#free chBox2,chKey12,chKey22,chKeyT2,chKeyTS,chKeyBS,chMachine2,chKey:channel.
#free b:ball.

    file.write("""event bid(ball,ball).
event won(ball,ball).
event bad().\n\n""")

def printParametersMachine(bidders, prices, file):
    for k in range(1,prices+1):
        for i in range(1,bidders+1):    
            file.write("ball%d%d:ball, " % (k, i))
    for k in range(1,prices+1):
        for i in range(1,bidders+1):    
            file.write("l%d%d:key, " % (k, i))
        file.write("l%ds:key, " % (k))
    for k in range(1,bidders+1):
        file.write("t%d:key, " % (k))
    for k in range(1,bidders+1):
        file.write("p%d:key, " % (k))
    file.write("ps:key, bs:key")
    for k in range(1,bidders*prices+1):
        file.write(", w%d:ball" % k)

def createVectorSub(l, x, y):
    if x == 1:
        for k in range(0, y+1):
            l.append([k])
        return l
    else:    
        for k in range(0, y+1):
            for m in createVectorSub([], x-1, y):
                m.append(k)
                l.append(m)
        return l

def createVector(bidders, prices):
    l=[]
    return createVectorSub(l, bidders, prices)

def createVectorZerosSub(l, x, y):
    if x < y:
        return l
    else:
        if x == 1:
            if y == 1:
                l.append([0])
            else:
                l.append([1])
            return l
        else:    
            if y > 0:
                l1 = createVectorZerosSub([], x-1, y-1)
                for m in l1:
                    m.append(0)
                l.extend(l1)
            if x-1 >= y:
                l0 = createVectorZerosSub([], x-1, y)
                for m in l0:
                    m.append(1)
                l.extend(l0)
            return l

def createVectorZeros(length, ones):
    l=[]
    return createVectorZerosSub(l, length, ones)


def printEquations(bidders, prices, file):
# check_window
    file.write("reduc forall ");
    printParametersMachine(bidders, prices, file)
    file.write("; check_window(machine(")
    for k in range(1,prices+1):
        for i in range(1,bidders+1):    
            file.write("ball%d%d, " % (k, i))
    for k in range(1,prices+1):
        for i in range(1,bidders+1):    
            file.write("l%d%d, " % (k, i))
        file.write("l%ds, " % (k))
    for k in range(1,bidders+1):
        file.write("t%d, " % (k))
    for k in range(1,bidders+1):
        file.write("p%d, " % (k))
    file.write("ps, bs")
    for k in range(1,bidders*prices+1):
        file.write(", w%d" % k)
    file.write(")) = (w1")
    for k in range(2,bidders*prices+1):
        file.write(", w%d" % k)
    file.write(").\n\n")
# price_i
    for k in range(1,prices+1):
        file.write("fun price_%s(box" % getString(k))
        for i in range(1,bidders+2):    
            file.write(", key")
        file.write("):box\n")
        l=createVector(bidders,prices)
        #print(l)
        first=True
        for m in l:
            if first:
                file.write("reduc forall ")
                first=False
            else:
                file.write("otherwise forall ")
            printParametersMachine(bidders, prices, file)
            file.write("; price_%s(machine(" % getString(k))
            for n in range(1, prices+1):
                if n == k:
                    for o in m:
                        file.write("%s, " % getString(o))
                else:
                    for i in range(1,bidders+1):    
                        file.write("ball%d%d, " % (n, i))
            for n in range(1,prices+1):
                for i in range(1,bidders+1):    
                    file.write("l%d%d, " % (n, i))
                file.write("l%ds, " % (n))
            for n in range(1,bidders+1):
                file.write("t%d, " % (n))
            for n in range(1,bidders+1):
                file.write("p%d, " % (n))
            file.write("ps, bs")
            for n in range(1,bidders*prices+1):
                file.write(", w%d" % n)
            file.write(")")
            for n in range(1,bidders+1):
                file.write(", l%d%d" % (k, n))
            file.write(", l%ds" % (k))
            file.write(") = machine(")
            for n in range(1, prices+1):
                if n == k:
                    for o in m:
                        file.write("%s, " % getString(0))
                else:
                    if n == k+1:
                        i = 1
                        for o in m:
                            if o == 0:
                                file.write("ball%d%d, " % (n, i))
                            else:
                                if o <= k:
                                    file.write("%s, " % getString(0))
                                else:
                                    file.write("%s, " % getString(o))
                            i = i + 1
                    else:
                        for i in range(1,bidders+1):    
                            file.write("ball%d%d, " % (n, i))
            for n in range(1,prices+1):
                for i in range(1,bidders+1):    
                    file.write("l%d%d, " % (n, i))
                file.write("l%ds, " % (n))
            for n in range(1,bidders+1):
                file.write("t%d, " % (n))
            for n in range(1,bidders+1):
                file.write("p%d, " % (n))
            file.write("ps, bs")
            for n in range(1,prices+1):
                if n <= k:
                    for o in range(0,m.count(n)):
                        file.write(", %s" % getString(n))
                    for o in range(m.count(n)+1,bidders+1):
                        file.write(", w%d" % ((n-1)*bidders+o))
                else:
                    for o in range(1,bidders+1):
                        file.write(", w%d" % ((n-1)*bidders+o))
            file.write(")\n")
        file.write(".\n\n")
# open_top
    for l in range(1,bidders+1):
        file.write("reduc forall ");
        printParametersMachine(bidders, prices, file)
        file.write("; open_top%d(machine(" % l)
        for k in range(1,prices+1):
            for i in range(1,bidders+1):    
                file.write("ball%d%d, " % (k, i))
        for k in range(1,prices+1):
            for i in range(1,bidders+1):    
                file.write("l%d%d, " % (k, i))
            file.write("l%ds, " % (k))
        for k in range(1,bidders+1):
            file.write("t%d, " % (k))
        for k in range(1,bidders+1):
            file.write("p%d, " % (k))
        file.write("ps, bs")
        for k in range(1,bidders*prices+1):
            file.write(", w%d" % k)
        file.write("), t%d) = (ball1%d" % (l, l))
        for k in range(2,prices+1):
            file.write(", ball%d%d" % (k, l))
        file.write(").\n\n")
# open_bottom
    file.write("fun open_bottom(box, key):bitstring\n")
    lst=[]
    for l in range(0,bidders+1):
        lst.extend(createVectorZeros(bidders,bidders-l))
    first=True
    for m in lst:
        if first:
            file.write("reduc forall ")
            first=False
        else:
            file.write("otherwise forall ")
        printParametersMachine(bidders, prices, file)
        file.write("; open_bottom(machine(")
        for n in range(1, prices+1):
            i=1
            for o in m:
                if o==0:
                    file.write("empty, ")
                else:
                    file.write("ball%d%d, " % (n, i))
                i=i+1
        for n in range(1,prices+1):
            for i in range(1,bidders+1):    
                file.write("l%d%d, " % (n, i))
            file.write("l%ds, " % (k))
        for n in range(1,bidders+1):
            file.write("t%d, " % (n))
        for n in range(1,bidders+1):
            file.write("p%d, " % (n))
        file.write("ps, bs")
        for n in range(1,bidders*prices+1):
            file.write(", w%d" % n)
        file.write("), bs) = (")
        first=True
        for o in m:
            if first:
                if o==0:
                    file.write("empty")
                else:
                    file.write("something")
                first=False
            else:
                if o==0:
                    file.write(", empty")
                else:
                    file.write(", something")
        file.write(")\n")
    file.write(".\n\n")
# Change top
    for l in range(1,bidders+1):
        file.write("reduc forall ");
        printParametersMachine(bidders, prices, file)
        file.write(", newball:ball; change_top%d(machine(" % l)
        for k in range(1,prices+1):
            for i in range(1,bidders+1):    
                file.write("ball%d%d, " % (k, i))
        for k in range(1,prices+1):
            for i in range(1,bidders+1):    
                file.write("l%d%d, " % (k, i))
            file.write("l%ds, " % (k))
        for k in range(1,bidders+1):
            file.write("t%d, " % (k))
        for k in range(1,bidders+1):
            file.write("p%d, " % (k))
        file.write("ps, bs")
        for k in range(1,bidders*prices+1):
            file.write(", w%d" % k)
        file.write("), newball, t%d" % l)
        for k in range(1,bidders+1):
            file.write(", p%d" % (k))
        file.write(", ps) = machine(")
        for k in range(1,prices+1):
            for i in range(1,bidders+1):    
                if l==i and k==1:
                    file.write("newball, ")
                else:
                    file.write("ball%d%d, " % (k, i))
        for k in range(1,prices+1):
            for i in range(1,bidders+1):    
                file.write("l%d%d, " % (k, i))
            file.write("l%ds, " % (k))
        for k in range(1,bidders+1):
            file.write("t%d, " % (k))
        for k in range(1,bidders+1):
            file.write("p%d, " % (k))
        file.write("ps, bs")
        for k in range(1,bidders*prices+1):
            file.write(", w%d" % k)
        file.write(").\n\n")


def printProcesses(bidders, prices, file):
    file.write("let procMachine(")
    for k in range(1,bidders+1):
        file.write("chBox%d:channel, " % k)
    for k in range(1,prices+1):
        for l in range(1,bidders+1):
            file.write("chKey%d%d:channel, " % (k,l))
        file.write("chKey%ds:channel, " % (k))
    for k in range(1,bidders+1):
        file.write("chKeyT%d:channel, " % k)
    for k in range(1,bidders+1):
        file.write("chKeyP%d:channel, " % k)
    file.write("chKeyPS:channel, chKeyBS:channel")
    for k in range(1,bidders+1):
        file.write(", chMachine%d:channel" % k)
    file.write(", chMachineS:channel")
    file.write(")=\n")
    for k in range(1,bidders+1):
        file.write("  in(chBox%d, ball%d:ball);\n" % (k, k))
    for k in range(1,prices+1):
        for l in range(1,bidders+1):
            file.write("  in(chKey%d%d, l%d%d:key);\n" % (k,l, k,l))
        file.write("  in(chKey%ds, l%ds:key);\n" % (k,k))
    for k in range(1,bidders+1):
        file.write("  in(chKeyT%d, t%d:key);\n" % (k, k))
    for k in range(1,bidders+1):
        file.write("  in(chKeyP%d, p%d:key);\n" % (k, k))
    file.write("  in(chKeyPS, ps:key);\n  in(chKeyBS, bs:key);\n")
    for k in range(1,bidders+1):
        file.write("  out(chMachine%d, machine(" % k)
        for k in range(1,bidders+1):
            file.write("ball%d, " % (k))
        for k in range(1,prices):
            for l in range(1,bidders+1):
                file.write("empty, ")
        for k in range(1,prices+1):
            for l in range(1,bidders+1):
                file.write("l%d%d, " % (k,l))
            file.write("l%ds, " % (k))
        for k in range(1,bidders+1):
            file.write("t%d, " % (k))
        for k in range(1,bidders+1):
            file.write("p%d, " % (k))
        file.write("ps, bs")
        for k in range(1,prices+1):
            for l in range(1,bidders+1):
                file.write(", empty")
        file.write("));\n")
    file.write("  out(chMachineS, machine(")
    for k in range(1,bidders+1):
        file.write("ball%d, " % (k))
    for k in range(1,prices):
        for l in range(1,bidders+1):
            file.write("empty, ")
    for k in range(1,prices+1):
        for l in range(1,bidders+1):
            file.write("l%d%d, " % (k,l))
        file.write("l%ds, " % (k))
    for k in range(1,bidders+1):
        file.write("t%d, " % (k))
    for k in range(1,bidders+1):
        file.write("p%d, " % (k))
    file.write("ps, bs")
    for k in range(1,prices+1):
        for l in range(1,bidders+1):
            file.write(", empty")
    file.write("));\n")
    file.write("0.\n\n")

    file.write("process\n  bidder |\n  procMachine\n")


# main function
if __name__ == '__main__':
    # no of bidders
    bidders = 2
    # no of prices
    prices = 3
    # output file
    output = open("woodako-gen.pi", "w")
    printHeader(bidders, prices, output)
    printEquations(bidders, prices, output)
    printProcesses(bidders, prices, output)
    output.close()
    #sys.exit(0)
